var dbname = '';
var cardColumnData = [];
var bookColumnData = [];
var bookRowData;

$(document).ready(function () {
  $(document).on("click", ".list-group-item", function () {
    $(this).addClass('active').siblings().removeClass('active');
    if (this.getAttribute('id') == "db-list-item") {
      $('#card_toolbar').addClass("hidden");
      $('#card_table').bootstrapTable('destroy');
    }
  });


  $(document).on("click", "#query_bt", function () {
    querydb();
  });
  $(document).on("click", "#download-bt", function () {
    downloaddb();
  });

  $(function () {
    $("[data-toggle='tooltip']").tooltip();
  });

  toastr.options = {
    "closeButton": false,
    "debug": false,
    "newestOnTop": false,
    "progressBar": false,
    "positionClass": "toast-top-center",
    "preventDuplicates": false,
    "onclick": null,
    "showDuration": "300",
    "hideDuration": "1000",
    "timeOut": "2000",
    "extendedTimeOut": "1000",
    "showEasing": "swing",
    "hideEasing": "linear",
    "showMethod": "fadeIn",
    "hideMethod": "fadeOut"
  };

  getBooks(false);

  $('#excel_file').fileinput({
    language: 'zh',
    uploadUrl: '/addCardByExcel',
    showCaption: true,//是否显示被选文件的简介
    showUpload: true,//是否显示上传按钮
    showClose: false,//是否显示关闭按钮
    enctype: 'multipart/form-data',
    uploadAsync: false, //false 同步上传，后台用数组接收，true 异步上传，每次上传一个file,会调用多次接口
    browseClass: 'btn btn-primary',
    maxFileCount: 1,
    minFileCount: 1,
    uploadExtraData: function () {
      return bookRowData;
    },
    layoutTemplates: {
      actionUpload: '',//就是让文件上传中的文件去除上传按钮
      actionDelete: '',//去除删除按钮
      actionZoom: ''
    },
    allowedFileExtensions: ['xls']//接收的文件后缀
  }).on("filebatchuploadsuccess", function (event, data, previewId, index) {
    var result = data.response;
    if (result == undefined || !result.success) {
      toastr.error('文件解析失败', result.message);
      return;
    }
    toastr.success(result.message);
    getCardList(bookRowData.id, true)
  });


  $('#txt_file').fileinput({
    language: 'zh',
    uploadUrl: '/addBatchCard',
    showCaption: true,//是否显示被选文件的简介
    showUpload: true,//是否显示上传按钮
    showClose: false,//是否显示关闭按钮
    enctype: 'multipart/form-data',
    uploadAsync: false, //false 同步上传，后台用数组接收，true 异步上传，每次上传一个file,会调用多次接口
    browseClass: 'btn btn-primary',
    maxFileCount: 1,
    minFileCount: 1,
    uploadExtraData: function () {
      return bookRowData;
    },
    layoutTemplates: {
      actionUpload: '',//就是让文件上传中的文件去除上传按钮
      actionDelete: '',//去除删除按钮
      actionZoom: ''
    },
    allowedFileExtensions: ['txt']//接收的文件后缀
  }).on("filebatchuploadsuccess", function (event, data, previewId, index) {
    var result = data.response;
    if (result == undefined || !result.success) {
      toastr.error('文件解析失败', result.message);
      return;
    }
    toastr.success(result.message);
    getCardList(bookRowData.id, true)
  });

});

/**
 * 获取全部词库
 */
function getBooks(isRefresh) {

  var curPageNumber = 1;
  var curPageSize = 10;
  if (isRefresh) {
    curPageNumber = $('#book_table').bootstrapTable('getOptions').pageNumber
    curPageSize = $('#book_table').bootstrapTable('getOptions').pageSize
  }

  $.ajax({
    url: "/getBookList",
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    success: function (result) {
      result = JSON.parse(result);
      if (!result.success) {
        toastr.error(result.message);
        return;
      }

      if (isRefresh) {
        //把每页显示2条数据更新为每页显示5条数据
        $('#book_table').bootstrapTable('refreshOptions', { data: result.data });
        return;
      }

      bookColumnData = [{ field: 'title', title: '选择词库' }];

      $('#book_table').bootstrapTable('destroy').bootstrapTable({ //'destroy' 是必须要加的==作用是加载服务器//  //数据，初始化表格的内容Destroy the bootstrap table.
        data: result.data, //datalist 即为需要的数据
        dataType: 'json',
        toolbar: '#book_toolbar',
        data_locale: "zh-US", //转换中文 但是没有什么用处
        uniqueId: "id",
        pagination: true,
        pageList: [10, 25, 'ALL'],
        pageNumber: curPageNumber,
        pageSize: curPageSize, //每页显示的数量
        paginationLoop: false,
        paginationPreText: "上一页",
        paginationNextText: "下一页",
        paginationLoop: false,
        showRefresh: false,                  //是否显示刷新按钮
        //这里也可以将TABLE样式中的<tr>标签里的内容挪到这里面：
        columns: bookColumnData
      });

      $("#book_table").on('click-row.bs.table', function (e, row, element) {
        $('.info').removeClass('info'); //去除之前选中的行的，选中样式
        $(element).addClass('info'); //添加当前选中的 success样式用于区别
        bookRowData = row;
        getCardList(row.id, false);
      });

    }
  });
}

/**
 * 获取卡片列表
 */
function getCardList(bookId, isRefresh) {
  var curPageNumber = 1;
  var curPageSize = 10;
  if (isRefresh) {
    curPageNumber = $('#card_table').bootstrapTable('getOptions').pageNumber
    curPageSize = $('#card_table').bootstrapTable('getOptions').pageSize
  }
  $.ajax({
    url: "/getCardList?bookId=" + bookId,
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    success: function (result) {
      result = JSON.parse(result);
      if (!result.success) {
        toastr.error(result.message);
        return;
      }

      if (isRefresh) {
        //把每页显示2条数据更新为每页显示5条数据
        $('#card_table').bootstrapTable('refreshOptions', { data: result.data });
        return;
      }
      cardColumnData = [
        { checkbox: true },
        { field: 'id', title: 'id' },
        { field: 'cardFront', title: '卡片正面', sortable: true },
        { field: 'cardTip', title: '卡片提示', sortable: true },
        { field: 'cardBehind', title: '卡片反面', sortable: true },
        { field: 'detail', title: '卡片扩展', sortable: true },
        { field: 'id', title: '操作', width: 120, align: 'center', valign: 'middle', formatter: actionFormatter }];

      //操作栏的格式化
      function actionFormatter(value, row, index) {
        var result = "";
        result += "<a href='javascript:;' class='btn btn-primary' onclick=\"editCardForm(" + row.id + ")\"><span class='glyphicon glyphicon-pencil'></span>编辑</a>";
        return result;
      }

      $('#card_toolbar').removeClass("hidden");
      $('#card_table').bootstrapTable('destroy').bootstrapTable({ //'destroy' 是必须要加的==作用是加载服务器//  //数据，初始化表格的内容Destroy the bootstrap table.
        data: result.data, //datalist 即为需要的数据
        dataType: 'json',
        toolbar: '#card_toolbar',
        data_locale: "zh-US", //转换中文 但是没有什么用处
        uniqueId: "id",
        pagination: true,
        pageList: [10, 25, 50, 100, 200, 500],
        pageNumber: curPageNumber,
        paginationShowPageGo: true,
        search: true,
        pageSize: curPageSize, //每页显示的数量
        paginationPreText: "上一页",
        paginationNextText: "下一页",
        paginationLoop: false,
        showColumns: true,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        striped: true,                      //是否显示行间隔色
        showToggle: true,                    //是否显示详细视图和列表视图的切换按钮
        //>>>>>>>>>>>>>>导出excel表格设置
        showExport: true,  //是否显示导出按钮
        buttonsAlign: "right",  //按钮位置
        Icons: 'glyphicon-export',
        //这里也可以将TABLE样式中的<tr>标签里的内容挪到这里面：
        columns: cardColumnData,
        paginationShowPageGo: true
      });

    }
  });
}


/**
 * 创造添加数据的表单
 */
function addCardForm() {
  var body = '';
  $("#add_card_body").empty();
  for (var i = 2; i < cardColumnData.length - 1; i++) {

    if (cardColumnData[i].field != "dataType") {
      if (cardColumnData[i].field == "cardBehind") {
        body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + cardColumnData[i].title + "</label><div id=\"addCardBehindToolbar\"></div><div style=\"height: 100px;\" id=\"addCardBehindEditor\"></div></div>";
      } else if (cardColumnData[i].field == "detail") {
        body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + cardColumnData[i].title + "</label><div id=\"addDetailToolbar\"></div><div style=\"height: 100px;\" id=\"addDetailEditor\"></div></div>";
      } else {
        body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + cardColumnData[i].title + "</label><div><textarea id=\"addedit" + i + "\" class='form-control' " + "rows='3' " +
          "name='" + cardColumnData[i].field + "' " + ">" + "</textarea>  </div></div>";
      }
    }


  }



  $("#add_card_body").append(body);
  $("#add_card_modal").modal('show');

  var E = window.wangEditor
  //【注意】下面使用的 typescript 语法。如用 javascript 语法，把类型去掉即可。
  var editorConfig = {}
  editorConfig.placeholder = '请输入内容'

  var toolBarConfig = {}
  toolBarConfig.excludeKeys = [
    'fullScreen',
    'codeBlock',
    'insertTable',
    'insertVideo',
    'todo'
  ]

  // 创建编辑器
  addCardBehindEditor = E.createEditor({
    selector: '#addCardBehindEditor',
    config: editorConfig,
    mode: 'simple' // 或 'simple' 参考下文
  })
  // 创建工具栏
  const addCardBehindToolbar = E.createToolbar({
    editor: addCardBehindEditor,
    config: toolBarConfig,
    selector: '#addCardBehindToolbar',
    mode: 'simple' // 或 'simple' 参考下文
  })

  // 创建编辑器
  addDetailEditor = E.createEditor({
    selector: '#addDetailEditor',
    config: editorConfig,
    mode: 'simple' // 或 'simple' 参考下文
  })
  // 创建工具栏
  const addDetailToolbar = E.createToolbar({
    editor: addDetailEditor,
    selector: '#addDetailToolbar',
    config: toolBarConfig,
    mode: 'simple' // 或 'simple' 参考下文
  })



}

/**
 * 添加数据
 */
function addCardData() {
  var addInput = $("#add_card_body").find("textarea");
  var addData = {};
  if ($(addInput[0]).val() == "") {
    toastr.error("卡片正面不能为空");
    return;
  }

  for (var i = 0; i < addInput.length; i++) {
    addData[addInput[i].name] = $(addInput[i]).val();
  }
  addData["cardBehind"] = addCardBehindEditor.getHtml()
  addData["cardBehindPure"] = addCardBehindEditor.getText()
  addData["detail"] = addDetailEditor.getHtml()
  addData["bookId"] = bookRowData.id;

  $.ajax({
    url: "/addCard",
    type: "post",
    dataType: "json",
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    data: JSON.stringify(addData),
    success: function (result) {

      if (!result.success) {
        toastr.error("添加失败", result.message);
        return;
      }
      // $("#add_card_modal").modal('hide');
      for (var i = 0; i < addInput.length; i++) {
        $(addInput[i]).val("");
      }
      addCardBehindEditor.clear();
      addDetailEditor.clear();

      toastr.success(result.message);
      //            getCardList(bookRowData.id,true);
      $("#card_table").bootstrapTable('append', result.data);//_data----->新增的数据
    }
  });

}


/**
 * 创造添加数据的表单
 */
function addBatchCardForm() {
  var body = '<textarea class="form-control" placeholder="系统自动识别您输入的内容，每张卡片之间请以换行符分割..." rows="16"></textarea>';
  $("#add_batch_card_body").empty();
  $("#add_batch_card_body").append(body);
  $("#add_batch_card_modal").modal('show');

}

/**
*导出excel
*/
function exportExcel() {
  toastr.success("正在导出...");
  window.location.href = "/exportExcel?bookId=" + bookRowData.id + "&fileName=" + bookRowData.title;
}

/**
 * 批量添加数据
 */
function addCardByTxtForm() {
  $("#add_card_by_txt").modal('show');
}


function addCardByExcelForm() {
  $("#add_card_by_excel").modal('show');
}


/**
 * 创建修改数据表单
 */
function editCardForm(cardId) {

  var rowData = $("#card_table").bootstrapTable('getRowByUniqueId', cardId);

  var body = '';
  $("#edit_card_body").empty();
  var pk = '';
  var rows = 0;

  var behind = ""
  var detail = ""
  for (var i = 1; i < cardColumnData.length - 1; i++) {
    if (cardColumnData[i].field.toLowerCase() == "id" || cardColumnData[i].field.toLowerCase() == "_id" || cardColumnData[i].field == "Key" || cardColumnData[i].field == "dataType") {
      pk = "disabled";
      rows = 1;
    } else {
      pk = "";
      rows = 3;
    }
    value = "";
    if (typeof (rowData[cardColumnData[i].field]) != "undefined") {
      value = rowData[cardColumnData[i].field];
    }

    if (cardColumnData[i].field == "cardBehind") {
    if(value.indexOf("<p>") == -1){
         behind = value.split(/\n/).map(line => `<p>${line}</p>`).join('\n')
    }else{
         behind = value
    }
      body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + cardColumnData[i].title + "</label><div id=\"updateCardBehindToolbar\"></div><div style=\"height: 100px;\" id=\"updateCardBehindEditor\"></div></div>";
    } else if (cardColumnData[i].field == "detail") {
      detail = value
      body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + cardColumnData[i].title + "</label><div id=\"updateDetailToolbar\"></div><div style=\"height: 100px;\" id=\"updateDetailEditor\"></div></div>";
    } else {
      body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + cardColumnData[i].title + "</label><div ><textarea id=\"updateedit" + i + "\" class='form-control' " + "rows='" + rows + "' " +
        "name='" + cardColumnData[i].field + "' " + pk + ">" + value + "</textarea>  </div></div>";
    }


  }
  $("#edit_card_body").append(body);
  $("#edit_card_modal").modal('show');


  var E = window.wangEditor
  //【注意】下面使用的 typescript 语法。如用 javascript 语法，把类型去掉即可。
  var editorConfig = {}
  editorConfig.placeholder = '请输入内容'

  var toolBarConfig = {}
  toolBarConfig.excludeKeys = [
    'fullScreen',
    'codeBlock',
    'insertTable',
    'insertVideo',
    'todo'
  ]

//console.log(behind)
  // 创建编辑器
  updateCardBehindEditor = E.createEditor({
    selector: '#updateCardBehindEditor',
    config: editorConfig,
    html: behind,
    mode: 'simple' // 或 'simple' 参考下文
  })
  // 创建工具栏
  const updateCardBehindToolbar = E.createToolbar({
    editor: updateCardBehindEditor,
    config: toolBarConfig,
    selector: '#updateCardBehindToolbar',
    mode: 'simple' // 或 'simple' 参考下文
  })

  // 创建编辑器
  updateDetailEditor = E.createEditor({
    selector: '#updateDetailEditor',
    config: editorConfig,
    html: detail,
    mode: 'simple' // 或 'simple' 参考下文
  })
  // 创建工具栏
  const updateDetailToolbar = E.createToolbar({
    editor: updateDetailEditor,
    selector: '#updateDetailToolbar',
    config: toolBarConfig,
    mode: 'simple' // 或 'simple' 参考下文
  })

}

/**
 * 修改数据
 */
function editCardData() {

  var editInput = $("#edit_card_body").find("textarea");
  var editData = {};

  if ($(editInput[1]).val() == "") {
    toastr.error("卡片正面不能为空");
    return;
  }


  for (var i = 0; i < editInput.length; i++) {
    editData[editInput[i].name] = $(editInput[i]).val();
  }
  editData["cardBehind"] = updateCardBehindEditor.getHtml()
  editData["cardBehindPure"] = updateCardBehindEditor.getText()
  editData["detail"] = updateDetailEditor.getHtml()


  $.ajax({
    url: "/editCard",
    type: "post",
    dataType: "json",
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    data: JSON.stringify(editData),
    success: function (result) {
      if (!result.success) {
        toastr.error("修改失败", result.message);
        return;
      }
      $("#edit_card_modal").modal('hide');
      toastr.success(result.message);
      //            getCardList(bookRowData.id,true);
      $('#card_table').bootstrapTable('updateByUniqueId', { id: editData.id, row: editData });
    }
  });
}

/**
 * 创建删除数据表单
 */
function delCardFrom() {

  var rows = $("#card_table").bootstrapTable('getSelections');// 获得要删除的数据
  if (rows.length == 0) {// rows 主要是为了判断是否选中，下面的else内容才是主要
    toastr.error("请勾选需要删除的记录!");
    return;
  }

  $("#del_card_modal").modal('show');
}

/**
 * 删除数据
 */
function delCardData() {

  var rowDatas = $("#card_table").bootstrapTable('getSelections');// 获得要删除的数据
  var delDatas = [];
  for (var i = 0; i < rowDatas.length; i++) {
    delDatas.push(rowDatas[i].id)
  }

  $.ajax({
    url: "/delCardList",
    type: "post",
    dataType: "json",
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    data: JSON.stringify(delDatas),
    success: function (result) {

      if (!result.success) {
        toastr.error("删除数据失败", result.message);
        return;
      }
      $("#del_card_modal").modal('hide');
      toastr.success(result.message);
      //            getCardList(bookRowData.id,true);
      $('#card_table').bootstrapTable('remove', { field: 'id', values: delDatas });
    }
  });
}


//==================词库=============================


/**
 * 创造添加数据的表单
 */
function addBookForm() {
  var body = '';
  $("#add_book_body").empty();

  body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + "词库名称" + "</label><div ><input type=\"text\" class=\"form-control\" " +
    "name='" + "title" + "'>  </div></div>";

  body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + "词库备注" + "</label><div ><input type=\"text\" class=\"form-control\" " +
    "name='" + "introduce" + "'>  </div></div>";

  $("#add_book_body").append(body);
  $("#add_book_modal").modal('show');

}

/**
 * 添加数据
 */
function addBookData() {
  var addInput = $("#add_book_body").find("input");
  var addData = {};

  if ($(addInput[0]).val() == "") {
    toastr.error("词库名称不能为空");
    return;
  }

  for (var i = 0; i < addInput.length; i++) {
    addData[addInput[i].name] = $(addInput[i]).val();
  }

  $.ajax({
    url: "/addBook",
    type: "post",
    dataType: "json",
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    data: JSON.stringify(addData),
    success: function (result) {

      if (!result.success) {
        toastr.error("添加失败", result.message);
        return;
      }
      $("#add_book_modal").modal('hide');
      toastr.success(result.message);
      getBooks(true);
    }
  });

}

/**
 * 创建修改数据表单
 */
function editBookForm() {

  if (!$("table tr").hasClass("info")) {
    toastr.error("请选择词库");
    return;
  }

  var body = '';
  $("#edit_book_body").empty();

  body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + "词库名称" + "</label><div ><input type='text' class='form-control' " +
    "name='" + "title" + "' value='" + bookRowData.title + "'>  </div></div>";

  body += "<div class=\"form-group\">" + " <label class=\" control-label\">" + "词库备注" + "</label><div ><input type='text' class='form-control' " +
    "name='" + "introduce" + "' value='" + bookRowData.introduce + "'>  </div></div>";

  $("#edit_book_body").append(body);
  $("#edit_book_modal").modal('show');

}

/**
 * 修改数据
 */
function editBookData() {

  var editInput = $("#edit_book_body").find("input");
  var editData = {};
  if ($(editInput[0]).val() == "") {
    toastr.error("词库名称不能为空");
    return;
  }
  editData["id"] = bookRowData.id;
  for (var i = 0; i < editInput.length; i++) {
    editData[editInput[i].name] = $(editInput[i]).val();
  }

  $.ajax({
    url: "/editBook",
    type: "post",
    dataType: "json",
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    data: JSON.stringify(editData),
    success: function (result) {

      if (!result.success) {
        toastr.error("修改数据失败", result.message);
        return;
      }
      $("#edit_book_modal").modal('hide');
      toastr.success(result.message);
      getBooks(true);
    }
  });
}

/**
 * 创建删除数据表单
 */
function delBookFrom() {

  if (!$("table tr").hasClass("info")) {
    toastr.error("请选择词库");
    return;
  }

  $("#del_book_modal").modal('show');
}

/**
 * 删除数据
 */
function delBookData() {

  $.ajax({
    url: "/delBook?bookId=" + bookRowData.id,
    headers: { 'Content-Type': 'application/json;charset=utf8' },
    success: function (result) {
      result = JSON.parse(result);
      if (!result.success) {
        toastr.error("删除失败", result.message);
        return;
      }
      $("#del_book_modal").modal('hide');
      toastr.success(result.message);
      getBooks(true);
      $('#card_toolbar').addClass("hidden");
      $('#card_table').bootstrapTable("removeAll");
    }
  });
}
